/*
 * Watching.hpp
 *
 *  Created on: 02.11.2010
 *      Author: stephan
 */

#ifndef WATCHING_HPP_
#define WATCHING_HPP_
#define watching_hpp_version "$Revision: 1.3 $"

#include "VecOfLists.hpp"
#include "AssignInfos.hpp"
#include <fstream>
#include "ThreadGlobals.hpp"
#include "Cls.hpp"



struct WtchEle{
	uint64_t cls_or_lit	: 30;
	uint64_t is_shrt	: 1;
	uint64_t lrnt		: 1;
	uint64_t lbd_hig	: 2;
	uint64_t cach_lit	: 30;

	bool isShort()		const	{return is_shrt;}
	Literal getFrstLit() const	{return Literal(cach_lit);}
	Literal getSecLit() const	{asrt(isShort()); return Literal(cls_or_lit);}
	ClsP  getClsP()	const	{asrt(!isShort()); return ClsP(cls_or_lit);}

	WtchEle(const Literal& a, const Literal& b):
		cls_or_lit(b.idx()),is_shrt(true),lrnt(false),lbd_hig(0),cach_lit(a.idx()){
		asrt(getFrstLit()==a); asrt(getSecLit()==b);}

	WtchEle(const Literal& a, const ClsP& p, const bool is_lrnt, const uint32_t& lbd_high):
		cls_or_lit(p.idx()),is_shrt(false),lrnt(is_lrnt),lbd_hig(lbd_high),cach_lit(a.idx()){
		asrt(getFrstLit()==a); asrt(getClsP()==p); asrt(lbd_high==lbd_hig);}

	WtchEle(const WtchEle& we, const Literal& nl):
		cls_or_lit(we.cls_or_lit),is_shrt(false),lrnt(we.lrnt),lbd_hig(we.lbd_hig),cach_lit(nl.idx()){
		asrt(getFrstLit()==nl);}

};

//inline bool operator==(const WtchEle& a, const WtchEle& b){return a.wtchd==b.wtchd;}


class Watching{
	const VarVal&						vals;
	TGlobals&							glob;
	VecOfLists<WtchEle,Literal>			watches;

public:
	Watching(const VarVal& vls,TGlobals& g):vals(vls),glob(g),watches('W'){}
	inline bool bcpFindNewWatcher(const Literal& false_lit, const Literal& other, const WtchEle& curr_we);
	inline void clsCreateBinary(const Literal lit0, const Literal lit1);
	inline void clsCreateBinPart(const Literal& a, const Literal& b);
	inline void clsAddWtched(const Literal& to, const Literal& w, const ClsP& ptr, const bool lrnt, const uint32_t& lbd_high);
	inline uint32_t writeDimacs(std::ofstream& out, bool print_lrnt);

	template<class Visitor, class LitFlag>
	inline void BFS(const Literal& start, Visitor& visi, LitFlag& flags, const bool visit_start, const bool clear_flags,vector<Literal>& queue);
	template<class LitFlag>
	void clearBfsFlags(LitFlag& flags, vector<Literal>& queue);
	template<class CollVisi,class MarkVisi, class LitFlag>
	void collectCommon(Literal lits[], uint32_t lsz,CollVisi& coll, MarkVisi& mark, LitFlag& flags, vector<Literal>& common_out);



	//void keepBin(WIter<WtchEle>& iter, const WtchEle& bin);
	//void keepCls(WIter<WtchEle>& iter, const WtchEle& oth, const WtchEle& cls);

	WIter<WtchEle> getWtchOfW(const Literal& l)	{return watches.getWIter(l);}
	Iter<WtchEle> getWtchOf(const Literal& l)		{return watches.getIter(l);}
	Literal 		getLitWithSmallerList(const Variable& v)	{return watches.sizeOf(v.toPosLit()) < watches.sizeOf(v.toNegLit()) ? v.toPosLit() : v.toNegLit();}
	bool isEmpty(const Literal& lit) const		{return watches.sizeOf(lit)==0;}
	void finish(const Literal& lit, WIter<WtchEle> it){watches.finish(lit,it);}
	void clearOf(const Literal& l){watches.clear(l);}

	void enlarge(const uint32_t& sz){watches.enlarge(sz);}
	void reserveForTotal(const uint32_t& sz){ watches.reserveForTotal(sz);}
	uint32_t litsCount() const {return watches.listCount();}
	uint32_t getTotMem()const{return watches.getMemTotal();}
	void hardClear(){watches.hardClear();}

	inline bool asrtWtchingOK() const;
	inline bool asrtFindWtched(const Literal& lit, const ClsP& cand) const;
	inline bool asrtFindWtched(const Literal& lit, const Literal& cand) const;
};



bool	Watching::bcpFindNewWatcher(const Literal& false_lit, const Literal& other, const WtchEle& curr_we){

	Cls& cl 		= glob.getCls(curr_we.getClsP());
	ClsLit* clit 	= cl.uwBeg();
	do{
		if(!vals.litFalse(Literal(clit->lit))){
			cl		.changeWatchers(other,clit,false_lit); LOG2("Found new watcher "<<cl.otherWatcher(other).toDIMACS());
			watches.add(cl.otherWatcher(other),WtchEle(curr_we,other));
			return true;
		}
	}while((clit++)->propNext());

	return false;
}

void Watching::clsCreateBinPart(const Literal& a, const Literal& b){
	watches.add(a,WtchEle(b,FALSE_LIT));
}

void Watching::clsCreateBinary(const Literal lit0, const Literal lit1){

	watches.add(lit0,WtchEle(lit1,FALSE_LIT));
	watches.add(lit1,WtchEle(lit0,FALSE_LIT));
   	//++nbr_bin_clses;
	cnt_stat(bin_lts,2);
}

void	Watching::clsAddWtched(const Literal& to, const Literal& w, const ClsP& ptr, const bool lrnt, const uint32_t& lbd_high){
	watches.add(to,WtchEle(w,ptr,lrnt,lbd_high));
}


/*
uint32_t Watching::writeDimacs(std::ofstream& out, bool print_lrnt){

	uint32_t clses = 0;
	WtchEle we(INVALID_LIT,true); Literal oth; bool binary;
	for(uint32_t i=0;i!=watches.listCount();++i){
		Literal lit(i);
		Iter<WtchEle> iter = watches.getIter(lit);
		while(iter.getNext(we)){
			binary = we.isBinary();
			if(binary){
				oth = we.getLit();
			}else{
				asrt(iter.hasNext());
				iter.getNext(we);
				Cls& cls 	= glob.getCls(we.getClsP());
				if(!print_lrnt && cls.isLrnt()) continue;
				oth = cls.otherWatcher(lit);
			}

			if(oth < lit) continue;

			out << lit.toDIMACS() << " " << oth.toDIMACS() << " ";
			if(!binary){
				ClsLit* clit = glob.getCls(we.getClsP()).uwBeg();
				do{ out << clit->getLit().toDIMACS() << " ";}while((clit++)->has_next);
			}
			out << "0" << endl;
			++clses;
		}
	}
	return clses;
}
*/




//for each target the Visitor functor is called exactly once
//the second argument is the predecessor by which target was reached first -> hence not all edges are called with visitor
//if visit_start is true the start literal is visited with predecessor "FALSE_LIT"

/*
template<class Visitor, class LitFlag>
void Watching::BFS(const Literal& start, Visitor& visi, LitFlag& flags, const bool visit_start, const bool clear_flags,vector<Literal>& queue){
	asrt(!clear_flags || queue.empty());
	LOG2("BFS run with start " << start.toDIMACS());
	uint32_t qhead = queue.size(); WtchEle we(INVALID_LIT,true);
	if(!visit_start || visi(start,FALSE_LIT).isTrue()){
		flags.setFlag(start); queue.push_back(start);}

	Literal target;
	while(qhead != queue.size()){
		Literal src 		= queue[qhead++]; //asrt(!dag.isLitRepl(src));
		Iter<WtchEle>ii	= getWtchOf(src.flipped());

		while(ii.getNext(we)){
			if(!we.isBinary()){asrt(ii.hasNext());ii.skipNext(); continue;}
			target = we.getLit();

			if(flags.isSet(target)){		 continue;}
			TrBool v_res				= visi(target,src);
			if(v_res.isUnknown()){		qhead=queue.size();break;}
			if(v_res.isTrue()){
				flags.setFlag(target);	queue.push_back(target);}
		}
	}

	LOG2("Finishing BFS run with start " << start.toDIMACS());
	if(clear_flags){clearBFSFlags(flags,queue);}
}
*/

template<class LitFlag>
void Watching::clearBfsFlags(LitFlag& flags, vector<Literal>& queue){
	for(uint32_t i=queue.size();i--;){flags.clearFlag(queue[i]);}
	queue.clear();
}




template<class CollVisi,class MarkVisi, class LitFlag>
void Watching::collectCommon(Literal lits[], uint32_t lsz, CollVisi& coll, MarkVisi& mark, LitFlag& flags, vector<Literal>& common_out){

	if(lsz<2){	if(lsz==1){common_out.push_back(lits[0]);} return;}
	LOG2("Start search for common literals of " << lsz);
	vector<Literal> queue;

	BFS(lits[--lsz],coll,flags,true,true,queue);
	if(coll.common.empty()){LOG2("No common lits ");return;}

	while(lsz--){	asrt(!coll.common.empty());
		BFS(lits[lsz],mark,flags,true,false,queue);
		uint32_t cp = 0;
		for(uint32_t i=0;i!=coll.common.size();++i){
			if(flags.isSet(coll.common[i].first)){
				coll.common[cp++]=coll.common[i];LOG2("Keep lit "<<coll.common[i].first.toDIMACS());}
		}
		clearBFSFlags(flags,queue);
		if(cp == 0){LOG2("No common lits ");return;}
		coll.common.resize(cp);
	}
	asrt(!coll.common.empty());
	LOG2("By now common lits: " << coll.common.size());

	//take only topmost common literals -> others are redundant
	for(uint32_t i=coll.common.size();i--;){flags.setFlag(coll.common[i].first);LOG2("Flag lit"<<coll.common[i].first.toDIMACS());}
	for(uint32_t i=coll.common.size();i--;){
		if(!flags.isSet(coll.common[i].second)){common_out.push_back(coll.common[i].first);}
		else{LOG2("Dont take common " << coll.common[i].first.toDIMACS() << " because predecessor is taken: " << coll.common[i].second.toDIMACS());}
		flags.clearFlag(coll.common[i].first);
	}

	LOG2("Found common literals: " << common_out.size());
	asrt(!common_out.empty());
}


bool Watching::asrtFindWtched(const Literal& lit, const ClsP& cand) const{
	Iter<WtchEle> it = watches.getIter(lit);
	WtchEle we(FALSE_LIT,FALSE_LIT);
	while(it.getNext(we)){
		if(we.isShort()){continue;}
		if(we.getClsP()==cand) return true;
	}
	return false;
}


bool Watching::asrtFindWtched(const Literal& lit, const Literal& cand) const{
	Iter<WtchEle> it = watches.getIter(lit);
	WtchEle we(FALSE_LIT,FALSE_LIT);
	while(it.getNext(we)){
		if(!we.isShort()){ continue;}
		if(!vals.litKnwn(we.getSecLit())){
			LOG0("Binary " << lit.toDIMACS() << " and " << cand.toDIMACS() << " have unknown third lit");
			return false;}
		if(we.getFrstLit()==cand) return true;
	}
	return false;
}

bool Watching::asrtWtchingOK() const{
	bool ok = true; WtchEle we(FALSE_LIT,FALSE_LIT);
	Literal ol; ClsP oc;

	for(uint32_t i=watches.listCount();i--;){
		Literal lit(i);
		Iter<WtchEle> it = watches.getIter(lit);
		while(it.getNext(we)){
			if(we.isShort()){
				ol = we.getFrstLit();
				if(!asrtFindWtched(ol,lit)){ ok = false;
					LOG0("Binary " << lit.toDIMACS() << " and " << ol.toDIMACS() << " only one direction");}
			}else{
				if(!it.getNext(we)){LOG0("Bad watching number in lit " << lit.toDIMACS()); return false;}
				ClsP clp = we.getClsP();
				Cls& cls = glob.getCls(clp);
				ol		 = cls.otherWatcher(lit);
				if(!asrtFindWtched(ol,clp)){ok = false;
					LOG0("Clause " << clp.idx() << " only linked by " << lit.toDIMACS() << " but not by " << ol.toDIMACS());}
			}
		}
	}
	LOG1("Watching::asrtWtchingOK is " << (ok?"ok":"bad"));
	return ok;
}


#endif /* WATCHING_HPP_ */
