/*
 * Logging.hpp
 *
 *  Created on: 13.08.2009
 *      Author: stephan
 */

#ifndef LOGGING_HPP_
#define LOGGING_HPP_
#define logging_hpp_version "$Revision: 1.6 $"

#include <stdio.h>
#include <stdarg.h>
#include <vector>
#include <string>
#include <fstream>
#include "Assertion.hpp"

using std::vector;
using std::string;



/* Choose one
 * Higher level implies lower levels
 * LOGGING_ENABLED will be defined if at least one logging type is defined
 */
//#define LOGGING_DETAILS
//#define LOGGING_MEDIUM
//#define LOGGING_BASIC

//for debugging: print currently important messages
//#define LOGGING_ACTUAL

/* LOGGING_DETAILS enables function LOG3
 * LOGGING_MEDIUM enables function LOG2
 * LOGGING_BASIC enables function LOG1
 */


//from here it's automatic

//#define CONSOLE(args) std::cerr << "Thread " <<  omp_get_thread_num() << ": "<< args ;


#if defined (LOGGING_DETAILS) or defined (LOGGING_MEDIUM) or defined (LOGGING_BASIC) or defined (LOGGING_ACTUAL)
#ifndef LOGGING_ENABLED
#define LOGGING_ENABLED
#endif

inline double cpuUUUTime(){
	struct rusage ru;
    getrusage(RUSAGE_SELF, &ru);
    return (double)ru.ru_utime.tv_sec*1000000.0 + (double)ru.ru_utime.tv_usec ;
};

#define LOGGING_INIT(x) Logging logging(x);
struct Logging{
	std::ofstream* 	out;
	//uint64_t 		count;
	bool 			shall_log;

	Logging(string path):out(new std::ofstream(path.c_str())),shall_log(true){}

	bool canLog(){return shall_log;} //count++;

	std::ofstream& getOut(){
		std::ofstream& 	o = *out; asrt(!o.bad());
		o << std::endl ;
		//<< cpuUUUTime() << " & ";
		return o;}

	~Logging(){delete out;}
};

#define LOGGING_ON logging.shall_log = true;
#define LOGGING_OFF logging.shall_log = false;

#else
	#define LOGGING_INIT(x)
	//struct Logging{Logging(string path){}};

	#define LOGGING_ON 	asrt(true);
	#define LOGGING_OFF asrt(true);
#endif


#ifdef LOGGING_ENABLED
	extern Logging logging;
#endif

#ifdef LOGGING_DETAILS

#define LOG3(args) if(logging.canLog()){logging.getOut() << args <<";" << std::flush;}

#ifndef LOGGING_MEDIUM
#define LOGGING_MEDIUM
#endif


#else

#define LOG3(args) ( assert(true))

#endif



#ifdef LOGGING_MEDIUM

#define LOG2(args) if(logging.canLog()){logging.getOut() << args <<";" << std::flush;}


#ifndef LOGGING_BASIC
#define LOGGING_BASIC
#endif

#else

#define LOG2(args) ( assert(true))

#endif



#ifdef LOGGING_BASIC

#define LOG1(args) if(logging.canLog()){logging.getOut() << args <<";" << std::flush;}
#define LOG_COUNT 		logging.getOut() << "Number of logs " << logging.getCount() << std::flush;

#else

#define LOG1(args) ( assert(true))
#define LOG_COUNT 		( assert(true))

#endif

/*
#ifdef LOGGING_ACTUAL
#define LOG_ACT(args) {logging.getOut() << args <<";" << std::flush;}
#endif

#ifndef NDEBUG
#define ASRT_PRNT(args) std::cerr << args ; LOG1(args);
#else
#define ASRT_PRNT(args) std::cerr << endl << "c DONT USE THIS PRINT FUNCTION OUTSIDE ASSERTIONS" << endl;
#endif*/

#define LOG0(args) std::cout << "c "<< args << endl; LOG1(args);
//#define LOG_ALWAYS(args) assert(true);


#endif /* LOGGING_HPP_ */
